﻿using System;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;

namespace GeoTiffEPSG31466
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            winformsMap1.MapUnit = GeographyUnit.Meter;

            OpenStreetMapOverlay osmOverlay = new OpenStreetMapOverlay();
            osmOverlay.TileCache = new FileBitmapTileCache(@"d:\cache", "a");
            winformsMap1.Overlays.Add(osmOverlay);

            LayerOverlay overlay = new LayerOverlay();
            winformsMap1.Overlays.Add(overlay);

            GeoTiffRasterLayer geoTiffRasterLayer = new GeoTiffRasterLayer(@"D:\DOP20_2015_5472_31466.tif");
            geoTiffRasterLayer.Transparency = 100;
            geoTiffRasterLayer.ImageSource.Projection = GetProj4Projection31466();
            overlay.Layers.Add(geoTiffRasterLayer);

            ShapeFileFeatureLayer shpLayer = new ShapeFileFeatureLayer(@"D:\saarland-31467.shp");
            shpLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.SimpleColors.Blue, 2));
            shpLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            shpLayer.FeatureSource.Projection = GetProj4Projection31467();
            overlay.Layers.Add(shpLayer);

            geoTiffRasterLayer.Open();
            winformsMap1.CurrentExtent = geoTiffRasterLayer.GetBoundingBox();

            winformsMap1.Refresh();
        }

        private ManagedProj4Projection GetProj4Projection31466()
        {
            ManagedProj4Projection proj4 = new ManagedProj4Projection();
            proj4.ExternalProjectionParametersString = ManagedProj4Projection.GetSphericalMercatorParametersString(); 
            proj4.InternalProjectionParametersString = "+proj=tmerc +lat_0=-0.0011 +lon_0=5.99931 +k=1 +x_0=2500000 +y_0=0 +ellps=bessel +towgs84=598.1,73.7,418.2,0.202,0.045,-2.455,6.7 +units=m +no_defs";

            return proj4;
        }

        private ManagedProj4Projection GetProj4Projection31467()
        {
            ManagedProj4Projection proj4 = new ManagedProj4Projection();
            proj4.ExternalProjectionParametersString = ManagedProj4Projection.GetSphericalMercatorParametersString();
            proj4.InternalProjectionParametersString = "+proj=tmerc +lat_0=-0.0011 +lon_0=8.99924 +k=1 +x_0=3500000 +y_0=0 +ellps=bessel +towgs84=598.1,73.7,418.2,0.202,0.045,-2.455,6.7 +units=m +no_defs ";

            return proj4;
        }
    }
}
